var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  useCheatCode: () => useCheatCode,
  useSecretCode: () => useSecretCode
});
var React = __toModule(require("react"));
var import_xstate = __toModule(require("xstate"));
var import_react = __toModule(require("@xstate/react"));

// src/utils.ts
function isEqual(array1, array2) {
  return JSON.stringify(array1) === JSON.stringify(array2);
}
function takeRight(array, n) {
  if (n < 1)
    return [];
  return array.slice(-1 * n);
}

// src/index.ts
var initialContext = {
  cheatCodeKeys: void 0,
  typedKeys: []
};
var cheatCodeMachine = (0, import_xstate.createMachine)({
  context: initialContext,
  tsTypes: {},
  schema: {
    context: {},
    events: {}
  },
  id: "cheatCodeMachine",
  initial: "disabled",
  states: {
    disabled: {
      initial: "idle",
      states: {
        idle: {
          always: {
            actions: "resetTypedKeys",
            cond: "cheatCodeEntered",
            target: "#cheatCodeMachine.enabled"
          },
          on: {
            keydown: {
              actions: "record",
              target: "#cheatCodeMachine.disabled.recording"
            }
          }
        },
        recording: {
          after: {
            doneTyping: {
              actions: "resetTypedKeys",
              target: "#cheatCodeMachine.disabled.idle"
            }
          },
          always: {
            actions: "resetTypedKeys",
            cond: "cheatCodeEntered",
            target: "#cheatCodeMachine.enabled"
          },
          on: {
            keydown: {
              actions: "record",
              target: "#cheatCodeMachine.disabled.recording"
            }
          }
        }
      }
    },
    enabled: {
      initial: "idle",
      states: {
        idle: {
          always: {
            actions: "resetTypedKeys",
            cond: "cheatCodeEntered",
            target: "#cheatCodeMachine.disabled"
          },
          on: {
            keydown: {
              actions: "record",
              target: "#cheatCodeMachine.enabled.recording"
            }
          }
        },
        recording: {
          after: {
            doneTyping: {
              actions: "resetTypedKeys",
              target: "#cheatCodeMachine.enabled.idle"
            }
          },
          always: {
            actions: "resetTypedKeys",
            cond: "cheatCodeEntered",
            target: "#cheatCodeMachine.disabled"
          },
          on: {
            keydown: {
              actions: "record",
              target: "#cheatCodeMachine.enabled.recording"
            }
          }
        }
      }
    }
  }
}, {
  actions: {
    record: (0, import_xstate.assign)({
      typedKeys: (context, event) => [...context.typedKeys, event.key]
    }),
    resetTypedKeys: (0, import_xstate.assign)({
      typedKeys: initialContext.typedKeys
    })
  },
  delays: {
    doneTyping: 2e3
  },
  guards: {
    cheatCodeEntered: (context) => Array.isArray(context.cheatCodeKeys) && isEqual(takeRight(context.typedKeys, context.cheatCodeKeys.length), context.cheatCodeKeys)
  }
});
function useCheatCode(cheatCodeKeys) {
  const machineOpts = React.useMemo(() => ({
    context: { cheatCodeKeys }
  }), [cheatCodeKeys]);
  const [state, send] = (0, import_react.useMachine)(cheatCodeMachine, machineOpts);
  React.useEffect(() => {
    const handleKeydownEvent = (event) => {
      send(event);
    };
    window.addEventListener("keydown", handleKeydownEvent);
    return () => {
      window.removeEventListener("keydown", handleKeydownEvent);
    };
  }, [send]);
  return state.matches("enabled");
}
var useSecretCode = useCheatCode;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useCheatCode,
  useSecretCode
});
//# sourceMappingURL=index.js.map